--------------------------------------------------------------------------------
-- EETAC - CSD - P2 - http://digsys.upc.edu
--------------------------------------------------------------------------------
-- Octuple_MUX4 
-- Design strategy: behavioural defining the truth table (plan B)
--------------------------------------------------------------------------------
LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;

ENTITY Octuple_MUX4 IS

	PORT (
		Ch0, Ch1	: 	IN 	STD_LOGIC_VECTOR (7 downto 0); -- 8 bits per channel
		Ch2, Ch3	: 	IN 	STD_LOGIC_VECTOR (7 downto 0); -- 8 bits per channel
		S			:	IN 	STD_LOGIC_VECTOR (1 downto 0); -- select 4 channels
		E			: 	IN 	STD_LOGIC; 						-- enable input
		Y		   	: 	OUT STD_LOGIC_VECTOR (7 downto 0)
	  );

END Octuple_MUX4;

ARCHITECTURE truth_table OF Octuple_MUX4 IS  

BEGIN      
	
y	<= 	Ch0 when (s ="00" and E = '1') else
		Ch1 when (s ="01" and E = '1') else
		Ch2 when (s ="10" and E = '1') else
		Ch3 when (s ="11" and E = '1') else "00000000"; 

END truth_table;
